/* ========================================================================
 *                               Barrier.h
 * ------------------------------------------------------------------------
 *  Interface file for the Barrier class.
 *
 *  Copyright 1998 by G. Wade Johnson (Telescan, Inc.)
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( INCLUDED_BARRIER )
  #define INCLUDED_BARRIER

  class ManualResetEvent;
  class CriticalSection;

  #if !defined( INCLUDED_WINDOWS )
    #include <windows.h>
    #define INCLUDED_WINDOWS
  #endif
  #if !defined( INCLUDED_STRING )
    #include <string>
    #define INCLUDED_STRING
  #endif

  class Barrier
   {
    short             myMaxThreads;
    short             myNumThreads;
    std::string       myName;
    CriticalSection   *mypMutex;
    ManualResetEvent  *mypBarrier;

   public:
    Barrier( short num );                   // create Mutexes/Events
    Barrier( short num, const char *name ); // create Mutexes/Events
    ~Barrier();                             // close Mutexes/Events

    const std::string &getName() const { return myName; }

    void   Wait();
    void   Release();
   } ;

#endif
