/* ========================================================================
 *                         CriticalSection.h
 * ------------------------------------------------------------------------
 *  Interface file for the CriticalSection class.
 *
 *  Copyright 1997-1998 by G. Wade Johnson (Telescan, Inc.)
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( INCLUDED_CRITICALSECTION )
  #define INCLUDED_CRITICALSECTION

  #if !defined( INCLUDED_WINDOWS )
     #include <windows.h>
     #define INCLUDED_WINDOWS
  #endif
  #if !defined( INCLUDED_SYNCWRAPPER )
     #include "SyncWrapper.h"
  #endif

  class CriticalSection
   {
    CRITICAL_SECTION    myCriticalSection;
  public:
    // constructors
    CriticalSection();
    // destructor
    ~CriticalSection();

    // manipulators
    void     Wait();
//    BOOL     Try();
    void     Release();
   } ;

  class CriticalSectionLock : public SyncWrapper<CriticalSection>
   {
   public:
    CriticalSectionLock( CriticalSection &c )
     : SyncWrapper<CriticalSection>(c,CriticalSection::Wait,CriticalSection::Release)
     { }
    ~CriticalSectionLock() { }
   } ;

#endif
