/* ========================================================================
 *                            Event.h
 * ------------------------------------------------------------------------
 *  Interface file for the Event class.
 *
 *  Copyright 1997-1998 by G. Wade Johnson (Telescan, Inc.)
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( INCLUDED_EVENT )
  #define INCLUDED_EVENT

  #if !defined( INCLUDED_WINDOWS )
     #include <windows.h>
     #define INCLUDED_WINDOWS
  #endif
  #if !defined( INCLUDED_STRING )
    #include <string>
    #define INCLUDED_STRING
  #endif

  class Event
   {
    HANDLE       myHandle;
    std::string  myName;
  public:
    // constructors
    Event( bool bManualReset );
    Event( bool bManualReset, const char *pszName );
//    Event( a, bool bSet, bool bManualReset, const char *pszName );
    // destructor
    virtual ~Event();

    // accessors
    HANDLE             getHandle()        { return myHandle; }
    const std::string &getName()   const  { return myName; }

    // manipulators
    DWORD    Wait();
    DWORD    Wait( DWORD TimeOut );
    void     Set();
    void     Reset();
    void     Pulse();
   } ;


  class ManualResetEvent : public Event
   {
  public:
	  ManualResetEvent() : Event(true) {}
	  ManualResetEvent( const char *pszName )
	   : Event(true,pszName) {}
   };


  class AutoResetEvent : public Event
   {
  public:
	  AutoResetEvent() : Event(false) {}
	  AutoResetEvent( const char *pszName )
	   : Event(false,pszName) {}
   };

#endif
